YANG module file name convention
Internet-Draft draft-ietf-netmod-yang-module-filename-00
Per Andersson
Cisco Systems
per.ietf@ionio.se
OPS Area
NETMOD Working Group
This document presents YANG module file name convention. The convention extends the current YANG module file name using revision‑date, with the YANG semantic version extension. The YANG semantic version extension allows for an informative version to be associated with a particular YANG module revision.
Editorial note (To be removed by the RFC Editor)
In the YANG module versioning work it was previously defined in [I-D.ietf-netmod-yang-semver] that file names could use the revision label (YANG Semantic version extension) instead of the revision date, which is standardized in [RFC7950]. This work was removed in an attempt to progress the module versioning work, but the YANG versioning design team was tasked to address it by the NETMOD WG. This draft extends YANG module file names conformity with the possibility to use revision label instead of revision date.
Introduction
This document defines the YANG module file convention. It extends the current convention defined in [RFC7950], which uses revision-date, with the YANG semantic version extension defined in [I-D.ietf-netmod-yang-semver].
Motivation
The motivation for using YANG semantic version instead of revision date is that it carries information to the user. A revision date only tells the user that it has been updated, while, for instance, a YANG Semver version can tell the user about the module's compatibility level at a glance. Having this information available as early as possible, i.e. in the module file name, makes it possible to quickly identify the module revision; compared to searching in the file contents and checking the revisions. Having the YANG semantic version visible in the file name will make it easier to handle large sets of YANG modules.
The YANG module file name schema described in this draft is already deployed in the industry. Now is the time to standardize before several proprietary solutions emerge. One possibility is to propose a standard that gains operational experience.
It is relatively easy to update tooling to handle YANG semantic version in the YANG module file name according to this draft. However, it is recognized that the migration of all tooling within the industry will take time.
Module file names
This section updates Section 5.2 of [RFC7950], Section 5.2 of [RFC6020], and Section 3.2 of [RFC8407].
If a revision has an associated YANG semantic version (ys:version) then it MAY use the YANG semantic version instead of the revision date in the file name of a YANG file, where it takes the form:

    module-or-submodule-name [['@' revision-date]['#' ys:version]]
        ( '.yang' / '.yin' )

E.g., acme-router-module@2024-05-15.yang or acme‑router‑module#2.0.3.yang.
In short, the YANG semantic version is recommended in order to simplify for module consumers, i.e. to convey compatibility status without needing to read the module.
YANG module (or submodule) files MAY be identified using either revision-date or YANG semantic version (ys:version). Typically, only one file name SHOULD exist for the same module (or submodule) revision. Two file names, one with the revision date and another with the YANG semantic version, MAY exist for the same module (or submodule) revision, e.g., when migrating from one scheme to the other.
Coexistence with YANG Semver
As can be seen above, all valid identifiers for YANG semantic version are valid in the filename as well. Section 4.3 of [I-D.ietf-netmod-yang-semver]
The following example is a valid YANG module file name

    example-module#2.3.1_non_compatible+build2237refM443ss.yang

One consequence of this is that there might exist two child modules of version 2.0.0 with the same X.Y.Z digits (2.0.1) but different version labels:

    2.0.1-draft-superman-super-stuff-03

    2.0.1-draft-batman-cool-addition-07   (a competing draft)

Known incompatibilities
There are currently no known publicly available tools that support the YANG semantic version file name schema. There are known proprietary tooling that already uses the file name schema presented in this document.
At the IETF 119 Hackathon, there was a project that investigated the feasibility to modify popular YANG tooling to support the proposed schema. There was a successful attempt to modify pyang to support the file name schema and also "recommended-min" previously included in [I-D.ietf-netmod-yang-module-versioning]. Furthermore, there were efforts in researching yanger and libyang to support the schema, but the hackathon ended before these projects could be concluded.
Security Considerations
There are no security considerations for this draft.
References
Normative References
[RFC2119]

Key words for use in RFCs to Indicate Requirement Levels
S. Bradner
March 1997
BCP 14
RFC 2119
DOI 10.17487/RFC2119
[RFC6020]

YANG - A Data Modeling Language for the Network Configuration Protocol (NETCONF)
M. Bjorklund, Ed.
October 2010
RFC 6020
DOI 10.17487/RFC6020
[RFC7950]

The YANG 1.1 Data Modeling Language
M. Bjorklund, Ed.
August 2016
RFC 7950
DOI 10.17487/RFC7950
[RFC8407]

Guidelines for Authors and Reviewers of Documents Containing YANG Data Models
A. Bierman
October 2018
BCP 216
RFC 8407
DOI 10.17487/RFC8407
[RFC8174]

Ambiguity of Uppercase vs Lowercase in RFC 2119 Key Words
B. Leiba
May 2017
BCP 14
RFC 8174
DOI 10.17487/RFC8174
Informative References
[I-D.ietf-netmod-yang-semver]
[I-D.ietf-netmod-yang-module-versioning]
Acknowledgements
The author would like to thank Joe Clarke, Reshad Rahman, for their excellent technical reviews, support, and guidance.